/*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * This file is part of Qt Web Runtime.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#include "webwidgetrunner.h"

#include <QApplication>
#include <QDebug>
#include <QGraphicsWebView>

using namespace WRT::Maemo;

int main(int argc, char* argv[])
{
    QApplication app(argc, argv);

    QStringList args = QApplication::arguments();

    if (args.length() < 2) {
        qDebug() << "Usage:" << args[0] << "<desktop file path>";
        return 0;
    }

    WebWidgetRunner runner;
    if (!runner.load(args[1]))
        return 1;

    return app.exec();
}
