/*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * This file is part of Qt Web Runtime.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef serviceipcdefs_h
#define serviceipcdefs_h

#include <Qt/qglobal.h>

namespace WRT {

    #ifdef QT_MAKE_IPC_DLL
        # define SFWIPC_EXPORT Q_DECL_EXPORT
    #else
        # define SFWIPC_EXPORT Q_DECL_IMPORT
    #endif

    #ifdef QT_MAKE_IPC_SERVER_DLL
        # define SFWIPCSRV_EXPORT Q_DECL_EXPORT
    #else
        # define SFWIPCSRV_EXPORT Q_DECL_IMPORT
    #endif

    enum TServiceIPCBackends
        {
        EDefaultIPC,
        ELocalSocket,
        ESymbianServer,
        ESharedMemory
        };

    static const char FUNCTIONSEM[] = "_funclock";
    static const char SERVERSEM[] = "_serverlock";
    static const char SERVERNOTSTARTED[] = "0";
    static const char SERVERSTARTED[] = "1";

    #define GETSESSIONID   "GetSessionId"
    #define SETSESSIONINFO   "SetSessionInfo"
    #define SUBSCRIBEBROADCASTMSG "SubscribeBroadcastMsg"
}
#endif // serviceipcdefs_h
