#
# ============================================================================
#  Name        : npsfwqtplugin.pro
#  Part of     : WRT / Service Framework
#  Description : Project definition file for CWRT browser plugin
#  Version     : %version: 35 % << Don't touch! Updated by Synergy at check-out.
#
# Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
#
# This file is part of Qt Web Runtime.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#

TARGET       = npsfwqtplugin
TEMPLATE     = lib
CONFIG      += plugin

contains( what, ninetwo ) {
QT += webkit
DEFINES += CWRT_BUILDING_NINETWO
}

ROOT_DIR = $$PWD/../../..
WRT_DIR = $$ROOT_DIR/wrt
include($$WRT_DIR/cwrt-webkit.pri)

include($$PWD/../npsfwplugin/npsfwplugin.pri)

LIBS += -lwrtnpqtjsbinding
symbian {

    # Load predefined include paths (e.g. QT_PLUGINS_BASE_DIR) to be used in the pro-files
    load(data_caging_paths)

    TARGET.UID3 = 0x20026147
    TARGET.VID = 0x101FB657
    TARGET.CAPABILITY = ALL -TCB
    TARGET.EPOCALLOWDLLDATA = 1
    
    DEFINES += CWRT_S60_WEBKIT
    
    HEADERS += $$PWD/sfwnpqtplugin.h 
    SOURCES += $$PWD/sfwnpqtplugin.cpp
    
    debug {
        LIBS += -lflogger
    }
    
    npfwqtpluginDep.sources = npsfwqtplugin.dll
    npfwqtpluginDep.path = $$QT_PLUGINS_BASE_DIR/npqtplugins
    
    wrtnpqtjsbinding.sources = wrtnpqtjsbinding.dll                                                       
    wrtnpqtjsbinding.path = /sys/bin
    
    DEPLOYMENT += npfwqtpluginDep wrtnpqtjsbinding
    
    target.path += $$[QT_INSTALL_PLUGINS]/npqtplugins
    INSTALLS += target
}
