/*
* ============================================================================
*  Name        : QGroupsIterator.cpp
*  Part of     : serviceframework / WRT
*  Description : Qt Iterator for contacts
*  Version     : %version: 6 % << Don't touch! Updated by Synergy at check-out.
*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * This file is part of Qt Web Runtime.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#include "qgroupsiterator.h"
#include "qjsonizer.h"

QGroupsIterator::QGroupsIterator(QList<QContact> aGroups):iGroupIter(aGroups)
{
    iHasNext = true;
}

QGroupsIterator::~QGroupsIterator()
{

}

void QGroupsIterator::reset()
{

}

bool QGroupsIterator::hasNext()
{
    return iHasNext;
}

QVariant QGroupsIterator::next()
{
    QVariant var=NULL;

    if (!iGroupIter.hasNext()) {
        iHasNext = false;
    }

    if (iHasNext) {
        QContact group = iGroupIter.next();
        var = ContactsHelpers::createGroupInfoJSON(&group);
    } else {
        var = NULL;
        iHasNext = false;
    }

    //qDebug() << "var: " << var;
    return var;
}

void QGroupsIterator::close()
{

}


