# Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
#
# This file is part of Qt Web Runtime.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
#

#Definition of common absolute variables
CWRT_INSTALL_LIB_DIR = /usr/lib/cwrt
CWRT_INSTALL_BIN_DIR = /usr/bin
CWRT_INSTALL_PLUGIN_DIR = /usr/lib/cwrt/plugins
CWRT_INSTALL_SERVICE_DIR = /usr/lib/cwrt/serviceproviders
CWRT_INSTALL_NPPLUGIN_DIR = /usr/lib/browser-plugins
CWRT_INCLUDE = /usr/include/cwrt

#Definition of common "relative" variables
CWRT_INSTALL_QTWEBKIT_DIR = $$CWRT_INSTALL_LIB_DIR/qtwebkit
CWRT_WRT_INCLUDE = $$CWRT_INCLUDE/wrt

WRT_SECURITY_HEADERS = $$CWRT_WRT_INCLUDE/security
WRT_SERVICEFW_HEADERS = $$CWRT_WRT_INCLUDE/servicefw
WRT_IPC_HEADERS  =  $$CWRT_WRT_INCLUDE/ipc/serviceipc \
                    $$CWRT_WRT_INCLUDE/ipc/serviceipcserver


INCLUDEPATH +=  $$WRT_SECURITY_HEADERS \
                $$WRT_SERVICEFW_HEADERS \
                $$WRT_IPC_HEADERS

LIBS += -L$$CWRT_INSTALL_LIB_DIR

QMAKE_RPATHDIR = $$CWRT_INSTALL_LIB_DIR $$QMAKE_RPATHDIR
QMAKE_LIBDIR = $$QMAKE_LIBDIR $$CWRT_INSTALL_QTWEBKIT_DIR

target.path = $$CWRT_INSTALL_SERVICE_DIR

xml.path = $$CWRT_INSTALL_SERVICE_DIR/import/
xml.files = ./descriptionxml/$${TARGET}.xml

INSTALLS += xml target
