/*
* ============================================================================
*  Name        : qlocationsengine.h
*  Part of     : serviceframework / WRT
*  Description : Qt class for Location service
*  Version     : %version: 14 % << Don't touch! Updated by Synergy at check-out.
*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * This file is part of Qt Web Runtime.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#ifndef QLOCATIONENGINE_H
#define QLOCATIONENGINE_H

#include <QObject>
#include "qlocationservice.h"

// Qt Mobility header
#include <QGeoPositionInfoSource>
QTM_USE_NAMESPACE

class LocationProvider;

class LocationEngine : public QObject
{
    Q_OBJECT

private:
    LocationEngine(LocationProvider* prov);
    LocationEngine(const LocationEngine&);              // Prevent copy-construction
    LocationEngine& operator=(const LocationEngine&);   // Prevent assignment

public:
    virtual ~LocationEngine();
    static LocationEngine* getInstance(LocationProvider* parent);
    static void freeResources();
    QGeoPositionInfoSource* getPositionInfoSource();

private:
    static LocationEngine* pinstance;
    QGeoPositionInfoSource* m_positionInfoSource;
};

#endif // QLOCATIONENGINE_H
