# Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
#
# This file is part of Qt Web Runtime.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
#

INCLUDEPATH += .

#for widgetmanagerconstants
INCLUDEPATH += ../../widgetmanager/src

HEADERS += \
    $$PWD/CertificateManager.h

SOURCES += \
    $$PWD/CertificateManager.cpp

!symbian {
    !maemo {
         SOURCES += \
         $$PWD/platform/qt/CertificateManagerQt.cpp

	 HEADEARS += \
	 $$PWD/platform/qt/CertificateManagerQt.h
        
         INCLUDEPATH += $$PWD \
                        $$PWD/platform/qt
    }
}

symbian {
    HEADERS += \
        $$PWD/platform/s60/CertificateManagerS60_p.h \
        $$PWD/platform/s60/CertificateManagerS60.h \
        $$PWD/platform/s60/CertStore.h \
        $$PWD/platform/s60/CertValidator.h
    SOURCES += \
        $$PWD/platform/s60/CertificateManagerS60.cpp \
        $$PWD/platform/s60/CertStore.cpp \
        $$PWD/platform/s60/CertValidator.cpp

    LIBS += \
        -lcertstore \
        -lefsrv \
        -lctframework \
        -lx509 \
        -lcrypto \
        -lssl \
	-lpkixcert

    INCLUDEPATH +=  $$PWD/platform/s60
}

maemo {
    HEADERS += $$PWD/platform/maemo/CertificateManagerMaemo.h
    SOURCES += $$PWD/platform/maemo/CertificateManagerMaemo.cpp

    INCLUDEPATH +=  $$PWD/platform/maemo \
                    $$PWD
}

unix: !symbian {
	CONFIG += link_pkgconfig
	PKGCONFIG += libxml-2.0
}
