/*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * This file is part of Qt Web Runtime.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#ifndef __JSMENUITEM_FACTORY_H
#define __JSMENUITEM_FACTORY_H

#include "jsresourcewrapper.h"

#include <QMap>

namespace WRT {

class JSMenuItem;

class JSMenuItemFactory : public JSResourceWrapper
{
    Q_OBJECT

public:

    explicit JSMenuItemFactory();
    virtual ~JSMenuItemFactory();
    static JSMenuItem* item(int id);

public Q_SLOTS:
    int createMenuItem();

private:
    int m_id;
    static QMap<int, JSMenuItem*> s_menuItems;
};

}

#endif
